import json

import xbmc

from resources.lib.const import GENERAL
from resources.lib.kodilogging import service_logger


class Service(xbmc.Monitor):
    SERVICE_NAME = ''
    _event_callbacks = {}

    def onNotification(self, sender, method, data):
        if sender == GENERAL.PLUGIN_ID:
            command_info = json.loads(data)
            self.emit(command_info.get('command'), command_info.get('command_params'))

    def emit(self, service_event, params):
        service_logger.debug('Emitting service event %s' % service_event)
        self._event_callbacks.get(service_event, lambda **kwargs: None)(**params)
